/* 
   Program to load the TASM Intel Hex file into the DSP Board.

D
A no cost, non-exclusive license to use this dspload.c software is granted
 to all users of the TAPR/AMSAT DSP-93 DSP computer, with the restriction
 that it be used only for non-commercial amateur radio applications. ALL
 other uses are prohibited under this license. Copyright 1991, 1992, 1993
 and 1994, 1995 Robert S. Stricklin, Jr.,N5BRG. All rights reserved.



   Writen to compile with Aztec C. Also works under UNIX System V with few changes. Will need to change more to work under MS C or other DOS C compilers.

   Modified December 26, 1994 to take care of a problem with the check sum 
   function. Before changes if check sum was zero then the output was 100h
   not zero.

	May 24, 1995 Changed some int's to long's and a few counters were limited to 1000. Increased limits to 32000.

	August 17, 1995 ported to Linux by Jim Lynch, K4GVO
	October 30, 1995 fix a bug in setting baud rate by Jim Lynch, K4GVO


*/
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <termios.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#define delay(x) sleep(x)

char *stptok(const char *s, char *tok, size_t toklen, char *brk);
#define CLK_TCK 100

int fcomm;

main(argc, argv)
	int argc;
	char **argv;

{

	char buf[1024];
	int nc;
	int nl=1;
	char port[40];
	unsigned int Mask;
	int i=0, bit_ct=0, cmd=0, bit=0;
	int ck_sum=0;
	int  baud=0, word=0, stop=0, parity=0;
    	int div=0, bits=0, stops=0, par=0;
	int io=0;
	long addr=0;
	int addr1=0, addr2=0;
	int loop=0;
	int loop1=0;
	char str[120], file[30];
	int st;
	struct termios tempio;

	FILE *f0, *f1, *f2, *f3, *fopen();


	if (argc < 2) {        /* no args = no input show them how to do it */
		printf("\nUsage:  DSPLOAD FILENAME                Linux   VER:0.03\n");
		exit();
	}

	if( (f0=fopen("dspload.cfg","r+")) == NULL) { /* Configuration info */
		printf("\nUnable to open file: %s","dspload.cfg");
		exit();
	}
	strcpy(file,argv[1]); /* build file from base file name */
	strcat(file,".obj");
	if( (f1=fopen(file,"rb")) == NULL) {
		printf("\nUnable to find file: %s",file);
		exit();
	}
	strcpy(file,argv[1]);
	strcat(file,".HI");
	if( (f2=fopen(file,"w")) == NULL) {
		printf("\nUnable to write file: %s",file);
		exit();
	}
	strcpy(file,argv[1]);
	strcat(file,".LO");
	if( (f3=fopen(file,"w")) == NULL) {
		printf("\nUnable to write file: %s",file);
		exit();
	}
/* Go get the configuration info. */
#ifdef OLD
	fscanf(f0,"%1d",&port);
	fgets(str,130,f0);
	fscanf(f0,"%5d",&baud);
	fgets(str,130,f0);
	fscanf(f0,"%1d",&word);
	fgets(str,130,f0);
	fscanf(f0,"%1d",&stop);
	fgets(str,130,f0);
	fscanf(f0,"%1d",&parity);
	fgets(str,130,f0);
#endif
	fgets(str,130,f0);
	stptok(str,port,40," \t\n");
	fgets(str,130,f0);
	baud=atoi(str);
	fgets(str,130,f0);
	word=atoi(str);
	fgets(str,130,f0);
	stop=atoi(str);
	fgets(str,130,f0);
	parity=atoi(str);
	fclose(f0);

	/* Set up all the IO stuff */
	switch(baud) {
		case 1200:
			div=B1200;
			break;
		case 2400:
			div=B2400;
			break;
		case 4800:
			div=B4800;
			break;
		case 9600:
			div=B9600;
			break;
		case 19200:
			div=B19200;
			break;
		default:
			printf("Baud error in DSPLOAD.CFG file.");
			exit(0);
			break;
	}
	printf("%d\n",baud);
	switch(word) {
		case 5:
			bits=CS5;
			break;
		case 6:
			bits=CS6;
			break;
		case 7:
			bits=CS7;
			break;
		case 8:
			bits=CS8;
			break;
		default:
			printf("Word length error in DSPLOAD.CFG file.");
			exit(0);
			break;
	}
	switch(stop) {
		case 1:
			stops=0;
			break;
		case 2:
			stops=4;
			break;
		default:
			printf("Stop bit error in DSPLOAD.CFG file.");
			exit(0);
			break;
	}
	switch(parity) {
		case 0:
			par=0;
			break;
		case 1:
			par=PARODD;
			break;
		case 2:
			par=PARENB;
			break;
		default:
			printf("Parity bit error in DSPLOAD.CFG file.");
			exit(0);
			break;
	}

#ifdef OLD
	/* write to port to set up io  */

	outportb(io+3,(0x80 | bits | stops | par));/*stop and parity  and clr baud latch */
	outportb(io,(div & 0x0FF));
	div=(div & 0x0FF00)/0x100;
	outportb(io+1,div);
    	outportb(io+3,(bits | stops | par));  /*bits stop and parity and set baud latch */

	/* Set port bits to make sure DSP-93 will take data. */
    	outportb(io+4,3);  /*Clear RTS and DTR */
#endif
	Mask=par|div|bits;
	fcomm=open(port,O_RDWR);
        if(fcomm<=0) {
            fprintf(stderr,"Com open failed on %s\n",port);
            perror("Com open");
            exit(9);
        }
	/*
	if (!(fcntl (fcomm, F_GETFL) & O_NONBLOCK)) {
	   fcntl (fcomm, F_SETFL, (fcntl(fcomm, F_GETFL) | O_NONBLOCK));
	}
	*/
	tcgetattr(fcomm, &tempio);
	tempio.c_iflag = 0;
	tempio.c_oflag = 0;
	tempio.c_lflag = 0;
	tempio.c_cflag &= ~CSIZE;
	tempio.c_cflag &= ~PARENB;
	tempio.c_cflag &= ~PARODD;
	tempio.c_cflag |= bits|par ;
	tempio.c_cc[VMIN] = 1;
	tempio.c_cc[VTIME] = 0;
	st=cfsetospeed(&tempio,baud);
	if(st==-1) {
            fprintf(stderr,"cfsetospeed failed\n",port);
            perror("tcsetattr");
            exit(9);
	}
	st=cfsetispeed(&tempio,baud);
	if(st==-1) {
            fprintf(stderr,"cfsetispeed failed\n",port);
            perror("tcsetattr");
            exit(9);
	}
	st=tcsetattr(fcomm, TCSANOW, &tempio);
	if(st==-1) {
            fprintf(stderr,"tcsetattr failed\n",port);
            perror("tcsetattr");
            exit(9);
	}
#ifdef TEST1
	close(fcomm);
	fcomm=open("test.out",O_RDWR);
        if(fcomm<=0) {
            fprintf(stderr,"Com open failed on %s\n",port);
            perror("Com open");
            exit(9);
        }
#endif


	/* Start Sending commands and data to DSP-93 */
	loop=0;
	out(0x52,io);  /* R */
	delay(5);
	out(0x48,io);  /* H */
	while(cmd == 0) {
		if(loop++ > 32000){
			printf("Error in %s.obj file",argv[1]);
			exit(0);
		}
		fscanf(f1,":%2x",&bit_ct);
		bit_ct=bit_ct/2;
		fprintf(f2,":%02x",bit_ct);
		out(0x3a,io);
		hexout(bit_ct,io);
		ck_sum=bit_ct;
		fscanf(f1,"%4x",&addr);
		addr=addr/2;
        	addr1=(addr & 0x0ff00)/0x100;
        	addr2=(addr & 0x0ff);
		hexout(addr1,io);
		fprintf(f2,"%02x",addr1);
		ck_sum=ck_sum+addr1;
		hexout(addr2,io);
		fprintf(f2,"%02x",addr2);
		ck_sum=ck_sum+addr2;
		fscanf(f1,"%2x",&cmd);
		ck_sum=ck_sum+cmd;
		hexout(cmd,io);
		fprintf(f2,"%02x",cmd);
		loop1=0;
		while(bit_ct--) {
			fscanf(f1,"%2x",&bit); /* Pick up MSB */
			fprintf(f2,"%02x",bit);
			hexout(bit,io);
			ck_sum=ck_sum+bit;
			fscanf(f1,"%2x",&bit); /* Pick up LSB */
			if(loop1++ > 32000){
				printf("Error in %s.obj file",argv[1]);
				exit(0);
			}
		}
		ck_sum=((0x100-(ck_sum & 0x0FF)) & 0x0FF);
		fprintf(f2,"%02x\n",ck_sum);
		hexout(ck_sum,io);
		fscanf(f1,"%2x\n",&ck_sum);
		out(0x0d,io);
		out(0x0a,io);
		/* flush echoed data */
		nc=read(fcomm,buf,1024);
		printf("\rLine %4d",nl++);
		fflush(stdout);
	}
	fclose(f1);
	fclose(f2);

	strcpy(file,argv[1]);
	strcat(file,".obj");
	if( (f1=fopen(file,"r+")) == NULL) {
		printf("\nUnable to find file: %s",file);
		exit();
	}
	delay(2);
	cmd=0;
	out(0x4C,io);  /* L */
	while(cmd == 0) {
		if(loop++ > 32000){
			printf("Error in %s.obj file",argv[1]);
			exit(0);
		}
		fscanf(f1,":%2x",&bit_ct);
		bit_ct=bit_ct/2;
		fprintf(f3,":%02x",bit_ct);
		out(0x3a,io);
		hexout(bit_ct,io);
		ck_sum=bit_ct;
		fscanf(f1,"%4x",&addr);
		addr=addr/2;
        	addr1=(addr & 0x0ff00)/0x100;
        	addr2=(addr & 0x0ff);
		hexout(addr1,io);
		fprintf(f3,"%02x",addr1);
		ck_sum=ck_sum+addr1;
		hexout(addr2,io);
		fprintf(f3,"%02x",addr2);
		ck_sum=ck_sum+addr2;
		fscanf(f1,"%2x",&cmd);
		fprintf(f3,"%02x",cmd);
		ck_sum=ck_sum+cmd;
		hexout(cmd,io);
		while(bit_ct--) {
			fscanf(f1,"%2x",&bit); /* Pick up MSB */
			fscanf(f1,"%2x",&bit); /* Pick up LSB */
			fprintf(f3,"%02x",bit);
			hexout(bit,io);
			ck_sum=ck_sum+bit;
		}
		ck_sum=((0x100-(ck_sum & 0x0FF)) & 0x0FF);
		fprintf(f3,"%02x\n",ck_sum);
		hexout(ck_sum,io);
		fscanf(f1,"%2x\n",&ck_sum);
		out(0x0d,io);
		out(0x0a,io);
		/* flush echoed data */
		nc=read(fcomm,buf,1024);
		printf("\rLine %4d",nl++);
		fflush(stdout);
	}
	fclose(f1);
	fclose(f3);
	close(fcomm);
	printf("\nfinished\n");
}


out(data,port)
unsigned data, port; 
{
    unsigned char c;
    int st;

    c=(char) data;
#ifdef OLD
	int i=0, loop=0;
	while( (i & 0x20) != 0x20) {
		i=inportb(port+5);
		if(loop++ > 1000){
			printf("Error with COM port %x.\n",port);
			exit(0);
		}
	}
	outportb(port,data);
#endif
        st=write(fcomm,(char *)&c,1);
	if(st<1) {
	    fprintf(stderr,"write to comm port failed\n");
	    perror("write comm");
	    exit(9);
	}
	return;
}
hexout(data,port)
int data; 
int port;
{
	int i=0, hex=((data & 0x0f0)/0x10)+0x30;
	if(hex > 0x39) hex=hex+0x7;
	out(hex,port);
	hex=(data & 0x0f)+0x30;
	if(hex > 0x39) hex=hex+0x7;
	out(hex,port);
	return;
}
#ifdef OLD
delay(int sec)
{
	typedef long time_t;
	typedef long clock_t;

	typedef struct tm {
		short tm_sec;
		short tm_min;
		short tm_hour;
		short tm_mday;
		short tm_mon;
		short tm_year;
		short tm_wday;
		short tm_yday;
		short tm_isdst;
		short tm_hsec;
	};

	int t=0;
	short y=0, l=0;

	struct tm *buf;
	struct tm buffer;
	struct tm *dostime();
	return;
	buf=&buffer;
	buf->tm_sec=0;
	buf->tm_min=0;
	buf->tm_hour=0;
	buf->tm_mday=0;
	buf->tm_mon=0;
	buf->tm_year=0;
	buf->tm_wday=0;
	buf->tm_yday=0;
	buf->tm_isdst=0;
	buf->tm_hsec=0;

	while(sec > t) {
		dostime(buf);
		y=buf->tm_sec;
		if(y != l) {
			l=y;
			t++;
		}
	}
}
#endif

/*
**  stptok() -- public domain by Ray Gardner, modified by Bob Stout
**   		and fixed by Jim Lynch
**
**   You pass this function a string to parse, a buffer to receive the
**   "token" that gets scanned, the length of the buffer, and a string of
**   "break" characters that stop the scan.  It will copy the string into
**   the buffer up to any of the break characters, or until the buffer is
**   full, and will always leave the buffer null-terminated.  It will
**   return a pointer to the first non-breaking character after the one
**   that stopped the scan.
*/

char *stptok(const char *s, char *tok, size_t toklen, char *brk)
{
      char *lim, *b;

      if (!*s)
            return NULL;

      lim = tok + toklen - 1;
      while ( *s && tok < lim )
      {
            for ( b = brk; *b; b++ )
            {
                  if ( *s == *b )
                  {
                        *tok = 0;
			s++;
			while(*s) {
			    for ( b=brk;*b;b++) {
			        if( *s == *b ) {
				    break;
				}
			    }
			    if(*b == '\0')
                            return (char *)s;
			}
                        return (char *)s;
                  }
            }
            *tok++ = *s++;
      }
      *tok = 0;
      return (char *)s;
}
